﻿--Procediments 
--Taula seuempresa - ALTA // Manté les dades referents a les seus

DROP FUNCTION alta_seuempresa(character varying,character varying,character varying,character varying,date,character varying);
create or replace function alta_seuempresa(
	abm_codiseu varchar(10),
	abm_adreca varchar(100),
	abm_poblacio varchar(50),
	abm_codipostal varchar(5),
	abm_datainaguracio date,
	abm_nomresponsable varchar(50),
	OUT RSP text 	
 )
returns TEXT as
$$
declare id varchar(10);
begin

--Es comprova la duplicitat de les dades introduides
	select codiseu into id from uoc_recruitcat.seuempresa 
	where upper(adreca) = upper(abm_adreca)
	and upper(poblacio) = upper(abm_poblacio)
	and upper(codipostal) = upper(abm_codipostal);
	-- Si es troben dades duplicades es retorna un error
	if found then
		RSP = 'ERROR LA SEU AMB ADREÇA '||abm_adreca||' '||abm_codipostal||' - '||abm_poblacio||' JA ESTA REGISTRAT AMB EL ID '|| id;
		
	--Si NO s'insereixen les dades a la base de dades
	else
		INSERT INTO uoc_recruitcat.seuempresa 
		VALUES (abm_codiseu ,abm_adreca, abm_poblacio, abm_codipostal, abm_datainaguracio, abm_nomresponsable);
		RSP = 'OK';
	end if;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log
VALUES('alta_seuempresa', abm_codiseu ||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_codipostal||', '|| abm_datainaguracio||', '|| abm_nomresponsable ,RSP);
	

-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
     --Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log
VALUES('alta_seuempresa', abm_codiseu ||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_codipostal||', '|| abm_datainaguracio||', '|| abm_nomresponsable , 'ERROR '||RSP);


	
end
$$
language plpgsql;

--Taula seuempresa - MODIFICACIO // Manté les dades referents a les seus

DROP FUNCTION modificacio_seuempresa(character varying,character varying,character varying,character varying,date,character varying);
create or replace function modificacio_seuempresa(
	abm_codiseu varchar(10),
	abm_adreca varchar(100),
	abm_poblacio varchar(50),
	abm_codipostal varchar(5),
	abm_datainaguracio date,
	abm_nomresponsable varchar(50)	,
	OUT RSP text
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova la duplicitat de les dades introduides
	select codiseu into id from uoc_recruitcat.seuempresa 
	where upper(adreca) = upper(abm_adreca)
	and upper(poblacio) = upper(abm_poblacio)
	and upper(codipostal) = upper(abm_codipostal)
	and codiseu != abm_codiseu;
	--Si es troben es mostra un error al camp RSP
	if found then
		RSP ='ERROR LA SEU AMB ADREÇA '||abm_adreca||' '||abm_codipostal||' - '||abm_poblacio||' JA ESTA REGISTRAT AMB EL ID '|| id;		
	else
	--Si no es troba una igual s'actualitzen les dades de la seu.
		UPDATE uoc_recruitcat.seuempresa 
		SET adreca = abm_adreca,
		poblacio = abm_poblacio, 
		codipostal = abm_codipostal, 
		datainaguracio = abm_datainaguracio, 
		nomresponsable = abm_nomresponsable;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log
VALUES('modificacio_seuempresa', abm_codiseu ||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_codipostal||', '|| abm_datainaguracio||', '|| abm_nomresponsable ,RSP);
	

-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log
VALUES('modificacio_seuempresa', abm_codiseu ||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_codipostal||', '|| abm_datainaguracio||', '|| abm_nomresponsable , 'ERROR '||RSP);
	
end
$$
language plpgsql;



--Taula seuempresa - BAIXA // Manté les dades referents a les seus

DROP FUNCTION baixa_seuempresa(character varying);
create or replace function baixa_seuempresa(
	abm_codiseu varchar(10) ,
	OUT RSP text
		
 )
returns TEXT as
$$
declare id varchar(10);
begin

--Es comprova si existeix la seu
	select codiseu into id from uoc_recruitcat.seuempresa 
	where codiseu = abm_codiseu;
	--Si no existeix es mostra un error a RSP
	if not found then
		RSP ='ERROR LA SEU NO EXISTEIX';		
	else
	--Si existeix s'esborra de la base de dades
		DELETE FROM uoc_recruitcat.seuempresa 
		WHERE codiseu = abm_codiseu;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log
VALUES('baixa_seuempresa', abm_codiseu ,RSP);
	

-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log
	VALUES(' baixa_seuempresa', abm_codiseu, 'ERROR '||RSP);

end
$$
language plpgsql;


--Taula comercials - ALTA //Manté les dades referents als comercials.


DROP FUNCTION alta_comercials(character varying,character varying,character varying);
create or replace function alta_comercials(
	abm_codicomecial varchar(10),
	abm_nom varchar(50),
	abm_codiseu varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova la duplicitat de les dades introduides
	select codicomercial into id from uoc_recruitcat.comercials 
	where upper(nom) = upper(abm_nom)
	and codiseu = abm_codiseu;
	--Si es troba es mostra un error a RSP
	if found then
		RSP ='ERROR EL COMERCIAL '||abm_nom||' JA ESTA REGISTRAT AMB EL ID '|| id||' A LA SEU '||abm_codiseu;		
	else
	--Si NO es troba es guarden les dades a la base de dades
		INSERT INTO uoc_recruitcat.comercials 
		VALUES (abm_codicomecial ,abm_nom, abm_codiseu);
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO uoc_recruitcat.log
VALUES('alta_comercials' ,abm_codicomecial||', '||abm_nom||', '||abm_codiseu , RSP);

	
-- Catch errors
 EXCEPTION
     WHEN OTHERS THEN
         --Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
         INSERT INTO uoc_recruitcat.log
VALUES('alta_comercials' ,abm_codicomecial||', '|| abm_nom ||', '||abm_codiseu , RSP);

	
end
$$
language plpgsql;


--Taula comercials - MODIFICACIO //Manté les dades referents als comercials.

DROP FUNCTION modificacio_comercials(character varying,character varying,character varying);
create or replace function modificacio_comercials(
	abm_codicomercial varchar(10),
	abm_nom varchar(50),
	abm_codiseu varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova la duplicitat de les dades introduides
	select codicomercial into id from uoc_recruitcat.comercials 
	where upper(nom) = upper(abm_nom)
	and codiseu = abm_codiseu
	and codicomercial != abm_codicomercial;
	--Si exiteix duplicitat de dades es mostra un error a RSP
	if found then
		RSP ='ERROR EL COMERCIAL '||abm_nom||' JA ESTA REGISTRAT AMB EL ID '|| id||' A LA SEU '||abm_codiseu;		
	else
	--Si NO existeix duplicitat de dades s'actualitza amb les noves dades
		UPDATE uoc_recruitcat.comercials 
		SET nom = abm_nom, codiseu = abm_codiseu
		WHERE codicomercial = abm_codicomercial;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log
VALUES('modificacio_comercials' ,abm_codicomercial||', '|| abm_nom ||', '|| abm_codiseu , RSP);

-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log
VALUES('modificacio_comercials' ,abm_codicomercial||', '|| abm_nom ||', '|| abm_codiseu , RSP);
end
$$
language plpgsql;


--Taula comercials - BAIXA //Manté les dades referents als comercials.

DROP FUNCTION baixa_comercials(character varying);
create or replace function baixa_comercials(
	abm_codicomercial varchar(10) ,
	OUT RSP text
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si existeix el comercial a la base de dades.
	select codicomercial into id from uoc_recruitcat.comercials 
	where codicomercial = abm_codicomercial;
	--Si NO es troba es mostra un error
	if not found then
		RSP ='ERROR EL COMERCIAL AMB ID '||abm_codicomercial||' NO EXISTEIX ';		
	else
	--Si es troba s'esborra de la base de dades
		DELETE FROM uoc_recruitcat.comercials		
		WHERE codicomercial = abm_codicomercial;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log
VALUES('baixa_comercials' ,abm_codicomercial , RSP);

-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log
VALUES('baixa_comercials' ,abm_codicomercial , RSP);end
$$
language plpgsql;


--Taula Clients - ALTA //Manté les dades referents als clients

DROP FUNCTION alta_clients(character varying,character varying,character varying,character varying,character varying,character varying,character varying);
create or replace function alta_clients(
	abm_codiclient varchar(20),
	abm_nom varchar(50),
	abm_adreca varchar(100),
	abm_poblacio varchar(50),
	abm_telefon varchar(15),
	abm_codiseu varchar(10),
	abm_comercialresponsable varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(20);
begin
--Es comprova la duplicitat de les dades introduides
	select codiclient into id from uoc_recruitcat.clients 
	where upper(codiclient) = upper(abm_codiclient);
	--Si ja es troba el client donat de alta amb el CIF indicat es mostra un error
	if found then
		RSP ='ERROR EL CLIENT AMB ID '||abm_codiclient||' JA ESTA REGISTRAT';		
	else
	-- Si NO es troba s'insereix a la base de dades
		INSERT INTO uoc_recruitcat.clients 
		VALUES (abm_codiclient, abm_nom, abm_adreca, abm_poblacio, abm_telefon, abm_codiseu, abm_comercialresponsable );
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_clients', abm_codiclient||', '|| abm_nom||', '|| abm_adreca||', '||  abm_poblacio||', '||  abm_telefon||', '||  abm_codiseu||', '||  abm_comercialresponsable,RSP);	
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_clients', abm_codiclient||', '|| abm_nom||', '|| abm_adreca||', '||  abm_poblacio||', '||  abm_telefon||', '||  abm_codiseu||', '||  abm_comercialresponsable,RSP);
end
$$
language plpgsql;



--Taula Clients - MODIFICACIO //Manté les dades referents als clients


DROP FUNCTION modificacio_clients(character varying,character varying,character varying,character varying,character varying,character varying,character varying);
create or replace function modificacio_clients(
	abm_codiclient varchar(20),
	abm_nom varchar(50),
	abm_adreca varchar(100),
	abm_poblacio varchar(50),
	abm_telefon varchar(5),
	abm_codiseu varchar(10),
	abm_comercialresponsable varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si existeix el client.
	select codiclient into id from uoc_recruitcat.clients 
	where upper(codiclient) = upper(abm_codiclient);
-- Si no existeix es guarda un error a RSP
	if not found then
		RSP ='ERROR EL CLIENT AMB ID '||abm_codiclient||' NO ESTA REGISTRAT';		
	else
--S'actualitzen les dades del client	
		UPDATE uoc_recruitcat.clients 
		SET nom = abm_nom, adreca = abm_adreca, poblacio = abm_poblacio, telefon = abm_telefon, codiseu = abm_codiseu, comercialresponsable = abm_comercialresponsable
		WHERE upper(codiclient) = upper(abm_codiclient);
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_clients', abm_codiclient||', '|| abm_nom||', '|| abm_adreca||', '||  abm_poblacio||', '||  abm_telefon||', '||  abm_codiseu||', '||  abm_comercialresponsable,RSP);	
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_clients', abm_codiclient||', '|| abm_nom||', '|| abm_adreca||', '||  abm_poblacio||', '||  abm_telefon||', '||  abm_codiseu||', '||  abm_comercialresponsable,RSP);	

end
$$
language plpgsql;


--Taula Clients - BAIXA //Manté les dades referents als clients


DROP FUNCTION baixa_clients(character varying);
create or replace function baixa_clients(
	abm_codiclient varchar(20) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(20);
begin
--Es comprova si exiteix el client
	select codiclient into id from uoc_recruitcat.clients 
	where upper(codiclient) = upper(abm_codiclient);
	--Si NO existeix es mostra un error a RSP.
	if not found then
		RSP ='ERROR EL CLIENT AMB ID '||abm_codiclient||' NO EXISTEIX';		
	else
	--Si existeix s'esborra de la base de dades.
		DELETE FROM uoc_recruitcat.clients 
		WHERE codiclient = abm_codiclient;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_clients', abm_codiclient,RSP);	

-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_clients', abm_codiclient,RSP);	
end
$$
language plpgsql;


--Taula visitacomercial - ALTA //Manté les dades referents a les visites comercials mantingudes amb els clients

DROP FUNCTION alta_visitacomercial(character varying,date,character varying,character varying) ;
create or replace function alta_visitacomercial(
amb_codivisita varchar(10),
	abm_data date,
	abm_codicomercial varchar(10),
	abm_codiclient varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si exiteixen dades duplicades 
	select codivisita into id from uoc_recruitcat.visitacomercial 
	where data = abm_data 
	and codicomercial = abm_codicomercial
	and upper(codiclient) = upper(abm_codiclient);
	--Si existeixen dades duplicades es mostra un error a RSP
	if found then
		RSP ='ERROR JA EXISTEIX UNA VISITA AMB EL CLIENT '||abm_codiclient||' PER LA DATA '||abm_data||' AMB EL COMERCIAL '||abm_codicomercial;		
	else
	--Si NO existeixen s'inserten les dades a la base de dades.
		INSERT INTO uoc_recruitcat.visitacomercial 
		VALUES(amb_codivisita ,abm_data,abm_codicomercial,abm_codiclient);
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_visitacomercial', amb_codivisita||', '|| abm_data||', '||abm_codicomercial||', '||abm_codiclient ,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_visitacomercial', amb_codivisita||', '|| abm_data||', '||abm_codicomercial||', '||abm_codiclient ,RSP);
	
end
$$
language plpgsql;


--Taula visitacomercial - MODIFICACIO //Manté les dades referents a les visites comercials mantingudes amb els clients

DROP FUNCTION modificacio_visitacomercial(character varying,date,character varying,character varying);
create or replace function modificacio_visitacomercial(
	amb_codivisita varchar(10),
	abm_data date,
	abm_codicomercial varchar(10),
	abm_codiclient varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si existeixen dades duplicades
	select codivisita into id from uoc_recruitcat.visitacomercial 
	where codivisita != amb_codivisita
	and data = abm_data
	and codicomercial = abm_codicomercial
	and codiclient = abm_codiclient;
	if found then
	--Si existeixen es mostra un error a RSP
		RSP ='ERROR JA EXISTEIX UNA VISITA AMB EL CLIENT '||abm_codiclient||' PER LA DATA '||abm_data||' AMB EL COMERCIAL '||abm_codicomercial;		
	else
	--Si NO existeixen dades duplicades es actualitzen a la base de dades.
		UPDATE uoc_recruitcat.visitacomercial 
		SET data = abm_data, codicomercial = abm_codicomercial, codiclient = abm_codiclient
		WHERE codivisita = amb_codivisita;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_visitacomercial', amb_codivisita||', '|| abm_data||', '||abm_codicomercial||', '||abm_codiclient ,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_visitacomercial', amb_codivisita||', '|| abm_data||', '||abm_codicomercial||', '||abm_codiclient ,RSP);
	
end
$$
language plpgsql;



--Taula visitacomercial - BAIXA //Manté les dades referents a les visites comercials mantingudes amb els clients

create or replace function baixa_visitacomercial(
	abm_codivisita varchar(10) ,
	OUT RSP text	
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si existeix la visita comercial
	select codivisita into id from uoc_recruitcat.visitacomercial 
	where codivisita = abm_codivisita;
	--Si NO existeix es mostra un error a RSP
	if not found then
		RSP ='ERROR NO EXISTEIX UNA VISITA AMB ID '||abm_codivisita;		
	else
	-- Si existeix s'esborra de la base de dades.
		DELETE FROM uoc_recruitcat.visitacomercial		
		WHERE codivisita = abm_codivisita;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.	
INSERT INTO  uoc_recruitcat.log VALUES('baixa_visitacomercial', abm_codivisita,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_visitacomercial', amb_codivisita,RSP);
end
$$
language plpgsql;



--Taula processeleccio - ALTA //Manté les dades referents als diferents processos de selecció que els clients demanen


DROP FUNCTION alta_processeleccio(character varying,date,date,nivellestudis,character varying);
create or replace function alta_processeleccio(
	abm_codiproces varchar(10),
	abm_datainici date,
	abm_datafi date,
	abm_nivellestudis nivellestudis,
	abm_codiclient varchar(10) ,
	OUT RSP text
		
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si existeixen dades duplicades al sistema.
	select codiproces into id from uoc_recruitcat.processeleccio 
	where datainici = abm_datainici
	and datafi = abm_datafi
	and nivellestudis = abm_nivellestudis
	and codiclient = abm_codiclient;
	--Si existeixen es mostra un error a la sortida RSP
	if found then
		RSP ='ERROR JA EXISTEIX UN PROCES DE SELECCIO AMB DATES ENTRE '||abm_datainici||' - '||abm_datafi||' AMB NIVELL D´ESTUDIS '||abm_nivellestudis||' PEL CLIENT '||abm_codiclient;		
	else
	--Si no existeixen s'inserten les dades a la base de dades
		INSERT INTO uoc_recruitcat.processeleccio 
		VALUES(abm_codiproces,  abm_datainici,abm_datafi,abm_nivellestudis,abm_codiclient);
		RSP = 'OK';		
		
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_processeleccio', abm_codiproces||', '||  abm_datainici||', '||abm_datafi||', '||abm_nivellestudis||', '||abm_codiclient,RSP);	
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_processeleccio', abm_codiproces||', '||abm_datainici||', '||abm_datafi||', '||abm_nivellestudis||', '||abm_codiclient,RSP);end
$$
language plpgsql;



--Taula processeleccio - MODIFICACIO //Manté les dades referents als diferents processos de selecció que els clients demanen


DROP FUNCTION modificacio_processeleccio(character varying,date,date,nivellestudis,character varying);
create or replace function modificacio_processeleccio(
	abm_codiproces varchar(10),
	abm_datainici date,
	abm_datafi date,
	abm_nivellestudis nivellestudis,
	abm_codiclient varchar(10) ,
	OUT RSP text
		
 )
returns TEXT as
$$
declare id varchar(10);
begin

--Es comprova si existeixen dades duplicades al sistema.
	select codiproces into id from uoc_recruitcat.processeleccio 
	where datainici = abm_datainici
	and datafi = abm_datafi
	and nivellestudis = abm_nivellestudis
	and codiclient = abm_codiclient
	and codiproces != abm_codiproces;
	--Si existeixen dades duplicades es mostra un error a la sortida RSP.
	if found then
		RSP ='ERROR JA EXISTEIX UN PROCES DE SELECCIO AMB DATES ENTRE '||abm_datainici||' - '||abm_datafi||' AMB NIVELL D´ESTUDIS '||abm_nivellestudis||' PEL CLIENT '||abm_codiclient;		
	else
	--Si NO existeixen dades duplicades s'actualitzen a la base de dades
		UPDATE uoc_recruitcat.processeleccio 
		SET datainici = abm_datainici,datafi = abm_datafi,nivellestudis = abm_nivellestudis,codiclient = abm_codiclient
		WHERE codiproces = abm_codiproces;
		RSP = 'OK';
		
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_processeleccio', abm_codiproces||', '||abm_datainici||', '||abm_datafi||', '||abm_nivellestudis||', '||abm_codiclient,RSP);	
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_processeleccio', abm_codiproces||', '||  abm_datainici||', '||abm_datafi||', '||abm_nivellestudis||', '||abm_codiclient,RSP);end
$$
language plpgsql;


--Taula processeleccio - BAIXA //Manté les dades referents als diferents processos de selecció que els clients demanen

DROP FUNCTION baixa_processeleccio(character varying);
create or replace function baixa_processeleccio(
	abm_codiproces varchar(10) ,
	OUT RSP text		
 )
returns TEXT as
$$
declare id varchar(10);
begin
--Es comprova si existeix el procés de selecció
	select codiproces into id from uoc_recruitcat.processeleccio 
	where  codiproces = abm_codiproces;
	--Si NO existeix es mostra un error a la sortida RSP
	if not found then
		RSP ='ERROR NO EXISTEIX UN PROCES DE SELECCIO AMB ID '||abm_codiproces;		
	else
	--Si existeix d'esborren les dades de la base de dades.
		DELETE FROM uoc_recruitcat.processeleccio		
		WHERE codiproces = abm_codiproces;
		RSP = 'OK';
		
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_processeleccio', abm_codiproces,RSP);	
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_processeleccio', abm_codiproces,RSP);
end
$$
language plpgsql;



--Taula Candidats - ALTA //Manté les dades dels candidats a nous llocs de treball


DROP FUNCTION alta_candidats(character varying,character varying,character varying,nivellestudis,character varying,character varying,character varying,character varying);
create or replace function alta_candidats(
	abm_dni varchar(10),
	abm_nom varchar(50),
	abm_edat varchar(3),
	abm_nivellestudis nivellestudis,
	abm_adreca varchar(100),
	abm_poblacio varchar(50),
	abm_telefon varchar(15),
	abm_codiseu varchar(10)	,
	OUT RSP text
	
 )
RETURNS TEXT AS
$$
declare id varchar(50);
begin
--Es comprova que el codi d'usuari no estigui donat de alta a la base de dades
	select nom into id from uoc_recruitcat.candidats where upper(dni) = upper(abm_dni);
	if found then
	--Si existeix es mostra un error a la sortida RSP
		RSP ='ERROR L´USUARI AMB DNI '||abm_dni||' JA ESTA REGISTRAT AMB EL NOM '|| id;		
	else
	--Si NO existeix s'inserta en la base de dades.
		INSERT INTO uoc_recruitcat.candidats
		VALUES (upper(abm_dni), abm_nom, abm_edat, abm_nivellestudis, abm_adreca, abm_poblacio, abm_telefon, abm_codiseu);
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_candidats',upper(abm_dni) ||', '|| abm_nom||', '|| abm_edat||', '|| abm_nivellestudis||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_telefon||', '|| abm_codiseu, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_candidats',upper(abm_dni) ||', '|| abm_nom||', '|| abm_edat||', '|| abm_nivellestudis||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_telefon||', '|| abm_codiseu, RSP);
	
end
$$
language plpgsql;


--Taula Candidats - MODIFICACIO //Manté les dades dels candidats a nous llocs de treball

DROP FUNCTION modificacio_candidats(character varying,character varying,character varying,nivellestudis,character varying,character varying,character varying,character varying);
create or replace function modificacio_candidats(
	abm_dni varchar(10),
	abm_nom varchar(50),
	abm_edat varchar(3),
	abm_nivellestudis nivellestudis,
	abm_adreca varchar(100),
	abm_poblacio varchar(50),
	abm_telefon varchar(15),
	abm_codiseu varchar(10)	,
	OUT RSP text
	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova si existeix el candidat
	select dni into id from uoc_recruitcat.candidats 
	where  dni = abm_dni;
	--Si no existeix es guarda un error al camp RSP
	if not found then
		RSP ='ERROR NO EXISTEIX L´USUARI AMB ID '||abm_dni;		
	else
	--Si existeix s'actualitzen les dades del candidat
		UPDATE uoc_recruitcat.candidats
		SET 	nom = abm_nom, 
			edat =  abm_edat, 
			nivellestudis = abm_nivellestudis, 
			adreca = abm_adreca, 
			poblacio = abm_poblacio, 
			telefon = abm_telefon, 
			codiseu = abm_codiseu
		WHERE dni = upper(abm_dni);
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_candidats',upper(abm_dni) ||', '|| abm_nom||', '|| abm_edat||', '|| abm_nivellestudis||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_telefon||', '|| abm_codiseu, RSP);
-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_candidats',upper(abm_dni) ||', '|| abm_nom||', '|| abm_edat||', '|| abm_nivellestudis||', '||abm_adreca||', '|| abm_poblacio||', '|| abm_telefon||', '|| abm_codiseu, RSP);

		
end
$$
language plpgsql;



--Taula Candidats - BAIXA //Manté les dades dels candidats a nous llocs de treball

DROP FUNCTION baixa_candidats(character varying);
create or replace function baixa_candidats(
	abm_dni varchar(10),
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--Es comprova si existeix el candidat
	select dni into id from uoc_recruitcat.candidats 
	where  dni = abm_dni;
		--Si NO existeix es guarda un error al camp RSP
	if not found then
		RSP ='ERROR NO EXISTEIX L´USUARI AMB ID '||abm_dni;		
	else
		--Si existeix s'esborren les dades del candidat
		DELETE FROM uoc_recruitcat.candidats		
		WHERE dni = upper(abm_dni);
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_candidats',upper(abm_dni), RSP);
-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_candidats',upper(abm_dni), RSP);
		
end
$$
language plpgsql;



--Taula entrevista - ALTA //Manté les dades referents a la entrevista interna que s’ha de fer a un candidat


DROP FUNCTION alta_entrevista(character varying,date,text,character varying);
create or replace function alta_entrevista(
	abm_codientrevista varchar(10),
	abm_data date,
	abm_notes text,
	abm_codicandidat varchar(10) ,
	OUT RSP text	
	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--Es comprova si existeixen dades duplicades
	select codientrevista into id from uoc_recruitcat.entrevista where data = abm_data and codicandidat = abm_codicandidat;
	if found then
	--Si existeixen es mostra un error al camp RSP
		RSP ='ERROR JA EXISTEIX UNA ENTREVISTA AMB L´USUARI '||abm_codicandidat||' A DATA DE '|| abm_data;		
	else
	--Si NO existeixen es guarden les dades a la base de dades.
		INSERT INTO uoc_recruitcat.entrevista 
		VALUES (abm_codientrevista, abm_data, abm_notes, abm_codicandidat);
		RSP = 'OK';
	end if;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_entrevista',abm_codientrevista||', '||abm_data||', '||abm_notes||', '||abm_codicandidat,RSP);
-- Catch errors	
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_entrevista',abm_codientrevista||', '||abm_data||', '||abm_notes||', '||abm_codicandidat,RSP);
end
$$
language plpgsql;


--Taula entrevista - MODIFICACIO //Manté les dades referents a la entrevista interna que s’ha de fer a un candidat


DROP FUNCTION modificacio_entrevista(character varying,date,text,character varying);
create or replace function modificacio_entrevista(
	abm_codientrevista varchar(10),
	abm_data date,
	abm_notes text,
	abm_codicandidat varchar(10) ,
	OUT RSP text	
	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin

--Es comprova si existeixen dades duplicades
	select codientrevista into id from uoc_recruitcat.entrevista where data = abm_data and codicandidat = abm_codicandidat and codientrevista != abm_codientrevista;
	if found then
	--Si es troben es mostra un error al camp RSP.
		RSP ='ERROR JA EXISTEIX UNA ENTREVISTA AMB L´USUARI '||abm_codicandidat||' A DATA DE '|| abm_data;		
	else
	--Si no es troben dades duplicades s'actualitzen les dades al sistema.
		UPDATE uoc_recruitcat.entrevista 
		SET data = abm_data, notes = abm_notes,codicandidat = abm_codicandidat
		WHERE codientrevista = abm_codientrevista;
		RSP = 'OK';
	end if;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_entrevista',abm_codientrevista||', '||abm_data||', '||abm_notes||', '||abm_codicandidat,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_entrevista',abm_codientrevista||', '||abm_data||', '||abm_notes||', '||abm_codicandidat,RSP);
	
end
$$
language plpgsql;



--Taula entrevista - BAIXA //Manté les dades referents a la entrevista interna que s’ha de fer a un candidat

DROP FUNCTION baixa_entrevista(character varying);
create or replace function baixa_entrevista(
	abm_codientrevista varchar(10) ,
	OUT RSP text	
 )	
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--Es comprova si existeixen dades per esborrar
	select codientrevista into id from uoc_recruitcat.entrevista where codientrevista = abm_codientrevista;
	--Si NO es troben es mostra un error al camp RSP.
	if not found then
		RSP ='ERROR NO EXISTEIX UNA ENTREVISTA AMB ID '||abm_codientrevista;		
	else
	--Si es troben dades s'esborren del sistema
		DELETE FROM uoc_recruitcat.entrevista 		
		WHERE codientrevista = abm_codientrevista;
		RSP = 'OK';
	end if;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_entrevista',abm_codientrevista,RSP);
-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_entrevista',abm_codientrevista,RSP);
end
$$
language plpgsql;



--Taula candidatsprocesseleccio - ALTA //Mante la llista de candidats que te els diferents processos de selecció demanat per els clients


DROP FUNCTION alta_candidatsprocesseleccio(character varying,character varying,decisio);
create or replace function alta_candidatsprocesseleccio(
	abm_codiproces varchar(10),
	abm_codicandidat varchar(10),
	abm_decisio decisio,
	OUT RSP text 
	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--S'inserten les dades al sistema. El sistema s'encarrega de comprobar si son dades duplicades.
	INSERT INTO uoc_recruitcat.candidatsprocesseleccio
	VALUES (abm_codiproces,abm_codicandidat,abm_decisio, current_date);
	RSP = 'OK';
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_candidatsprocesseleccio',abm_codiproces||', '||abm_codicandidat||', '||abm_decisio||', '||current_date, RSP);
-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_candidatsprocesseleccio',abm_codiproces||', '||abm_codicandidat||', '||abm_decisio||', '||current_date, RSP);
	
end
$$
language plpgsql;



--Taula candidatsprocesseleccio - MODIFICACIO //Mante la llista de candidats que te els diferents processos de selecció demanat per els clients

DROP FUNCTION modificacio_candidatsprocesseleccio(character varying,character varying,decisio);
create or replace function modificacio_candidatsprocesseleccio(
	abm_codiproces varchar(10),
	abm_codicandidat varchar(10),
	abm_decisio decisio ,
	OUT RSP text
	
 )
RETURNS TEXT AS
$$
declare id decisio;
begin
--Es comprova si existeixen dades al sistema
	SELECT decisio into id FROM uoc_recruitcat.candidatsprocesseleccio WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
	--Si NO existeixen es mostra un error indicant que no existeixen les dades al sistema.
	IF NOT found then
		RSP ='ERROR NO EXISTEIX LA ENTRADA SOLICITADA';
	ELSE
	--Si existeixen es modifiquen les dades al sistema.
		UPDATE uoc_recruitcat.candidatsprocesseleccio
		SET  decisio = abm_decisio, datadecisio = current_date
		WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_candidatsprocesseleccio',abm_codiproces||', '||abm_codicandidat||', '||abm_decisio||', '||current_date, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_candidatsprocesseleccio',abm_codiproces||', '||abm_codicandidat||', '||abm_decisio||', '||current_date, RSP);
	
end
$$
language plpgsql;



--Taula candidatsprocesseleccio - BAIXA //Manté la llista de candidats que te els diferents processos de selecció demanat per els clients


DROP FUNCTION baixa_candidatsprocesseleccio(character varying,character varying);
create or replace function baixa_candidatsprocesseleccio(
	abm_codiproces varchar(10),
	abm_codicandidat varchar(10) ,
	OUT RSP text
	
 )
RETURNS TEXT AS
$$
declare id decisio;
begin
--Es comprova que existeixen les dades al sistema.
	SELECT decisio into id FROM uoc_recruitcat.candidatsprocesseleccio 
	WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
	-- Si NO existeixen es mostra un error al camp RSP.
	IF NOT found then
		RSP ='ERROR NO EXISTEIX LA ENTRADA SOLICITADA';
	ELSE
	--Si existeixen s'esborren de la base de dades.
		DELETE FROM uoc_recruitcat.candidatsprocesseleccio
		WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
		RSP = 'OK';

	END IF;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_candidatsprocesseleccio',abm_codiproces||', '||abm_codicandidat, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_candidatsprocesseleccio',abm_codiproces||', '||abm_codicandidat, RSP);
end
$$
language plpgsql;



--Taula competenciesProfesionals - ALTA //Manté les diferents competències professionals


DROP FUNCTION alta_competenciesprofesionals(character varying,character varying);
create or replace function alta_competenciesprofesionals(
	abm_codicompetencia varchar(10),	
	abm_descripcio varchar(50) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova si existeixen dades duplicades al sistema.
	SELECT codicompetencia into id FROM uoc_recruitcat.competenciesprofesionals 
	WHERE upper(descripcio) = upper(abm_descripcio);
	IF found then
		-- Si existeixen dades duplicades es mostra un error al camp RSP
		RSP ='ERROR JA EXISTEIX LA COMPETENCIA PROFESIONAL AMB EL ID '||id;
	ELSE
		--Si NO es guarden les dades a la base de dades.
		INSERT INTO uoc_recruitcat.competenciesprofesionals 
		VALUES (abm_codicompetencia, abm_descripcio, current_date);
		RSP = 'OK';
	END IF;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_competenciesprofesionals', abm_codicompetencia||', '||abm_descripcio||', '||current_date, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_competenciesprofesionals', abm_codicompetencia||', '||abm_descripcio||', '||current_date, RSP);
end
$$
language plpgsql;



--Taula competenciaesProfesionals - MODIFICACIO //Manté les diferents competències professionals


DROP FUNCTION modificacio_competenciesprofesionals(character varying,character varying);
create or replace function modificacio_competenciesprofesionals(
	abm_codicompetencia varchar(10),
	abm_descripcio varchar(50) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
-- Es comprova si existeixen dades duplicades al sistema
	SELECT codicompetencia into id FROM uoc_recruitcat.competenciesprofesionals 
	WHERE upper(descripcio) = upper(abm_descripcio) AND codicompetencia != abm_codicompetencia;
	-- Si existeixen es mostra un error al camp RSP.
	IF found then
		RSP ='ERROR JA EXISTEIX LA COMPETENCIA PROFESIONAL AMB EL ID '||id;
	ELSE
	--Si NO existeixen s'actualitzen les dades al sistema
		UPDATE uoc_recruitcat.competenciesprofesionals 
		SET descripcio = abm_descripcio
		WHERE codicompetencia = abm_codicompetencia;
		RSP = 'OK';
	END IF;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_competenciesprofesionals', abm_codicompetencia||', '||abm_descripcio, RSP);
-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_competenciesprofesionals', abm_codicompetencia||', '||abm_descripcio, RSP);
end
$$
language plpgsql;



--Taula competenciaesProfesionals - BAIXA //Manté les diferents competències professionals


DROP FUNCTION baixa_competenciesprofesionals(character varying);
create or replace function baixa_competenciesprofesionals(
	abm_codicompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova que existeix la competència professional 
	SELECT codicompetencia into id FROM uoc_recruitcat.competenciesprofesionals WHERE codicompetencia = abm_codicompetencia;
	IF NOT found then
	--Si NO existeix es mostra un error al camp RSP.
		RSP ='ERROR NO EXISTEIX LA COMPETENCIA PROFESIONAL AMB EL ID '||abm_codicompetencia;
	ELSE
	--Si existeix s'esborra del sistema.
		DELETE FROM uoc_recruitcat.competenciesprofesionals 		
		WHERE codicompetencia = abm_codicompetencia;
		RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_competenciesprofesionals', abm_codicompetencia, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_competenciesprofesionals', abm_codicompetencia, RSP);
	
end
$$
language plpgsql;



--Taula competenciespercandidat - ALTA //Manté la llista de les diferents competències que els candidats tenen.

create or replace function alta_competenciespercandidat(
	abm_codicandidat varchar(10),
	abm_codicompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--S'inserta al sistema la competència per candidat. El sistema determina si existeixen dades duplicades.
	INSERT INTO uoc_recruitcat.competenciespercandidat 		
	VALUES (abm_codicandidat, abm_codicompetencia);
	RSP = 'OK';
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_competenciespercandidat', abm_codicandidat||', '||abm_codicompetencia,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_competenciespercandidat', abm_codicandidat||', '||abm_codicompetencia,RSP);
		
end
$$
language plpgsql;


--Taula competenciespercandidat - MODIFICACIO //Manté la llista de les diferents competències que els candidats tenen.


DROP FUNCTION modificacio_competenciespercandidat(character varying,character varying,character varying);
create or replace function modificacio_competenciespercandidat(
	abm_codicandidat varchar(10),
	abm_codicompetencia varchar(10),
	abm_novacompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--S'actualitza les dades de les competències per candidat.
	UPDATE uoc_recruitcat.competenciespercandidat 		
	SET codicompetencia = abm_novacompetencia
	WHERE codicandidat = abm_codicandidat AND codicompetencia = abm_codicompetencia;
	RSP = 'OK';
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_competenciespercandidat', abm_codicandidat||', '||abm_codicompetencia||', '|| abm_novacompetencia,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_competenciespercandidat', abm_codicandidat||', '||abm_codicompetencia||', '|| abm_novacompetencia,RSP);
		
end
$$
language plpgsql;



--Taula competenciespercandidat - BAIXA //Manté la llista de les diferents competències que els candidats tenen.

DROP FUNCTION baixa_competenciespercandidat(character varying,character varying);
create or replace function baixa_competenciespercandidat(
	abm_codicandidat varchar(10),
	abm_codicompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova si existeix dades al sistema
	SELECT codicompetencia INTO id FROM uoc_recruitcat.competenciespercandidat 
	WHERE codicandidat = abm_codicandidat AND codicompetencia = abm_codicompetencia;
	IF NOT FOUND THEN
	-- Si NO existeix es mostra un error al camp RSP
		RSP ='ERROR NO EXISTEIX LA RELACIO '||abm_codicandidat ||' AMB LA COMPETENCIA AMB ID '||abm_codicompetencia;
	ELSE
	-- Si existeixen dades s'esborren del sistema
		DELETE FROM uoc_recruitcat.competenciespercandidat 		
		WHERE codicandidat = abm_codicandidat AND codicompetencia = abm_codicompetencia;
		RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_competenciespercandidat', abm_codicandidat||', '||abm_codicompetencia,RSP);	
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_competenciespercandidat', abm_codicandidat||', '||abm_codicompetencia,RSP);	
end
$$
language plpgsql;



--Taula procesoscaptacio - ALTA //Manté els diferents processos de captació que la empresa ha d’efectuar per obtenir nous candidats


DROP FUNCTION alta_processoscaptacio(character varying,tipusprocescaptacio,date);
create or replace function alta_processoscaptacio(
	abm_codiproces varchar(10),
	abm_tipus tipusprocescaptacio,
	abm_datainici date,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin

	--Es comprova si existeixen dades duplicades al sistema
	SELECT codiproces INTO id FROM uoc_recruitcat.processoscaptacio 
	WHERE tipus = abm_tipus 
	AND datainici = abm_datainici;
	IF FOUND THEN
	--Si existeixen es mostra un errror al camp RSP
		RSP ='ERROR JA EXISTEIX LA RELACIO '||abm_tipus ||' AMB LA DATA '||abm_datainici;

	ELSE
	--Si NO existeixen es guarden les dades introduides.
		INSERT INTO uoc_recruitcat.processoscaptacio		
		VALUES (abm_codiproces, abm_tipus,abm_datainici); 
		RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_processoscaptacio', abm_codiproces||', '|| abm_tipus||', '||abm_datainici,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_processoscaptacio', abm_codiproces||', '|| abm_tipus||', '||abm_datainici,RSP);
end
$$
language plpgsql;



--Taula procesoscaptacio - MODIFICACIO //Manté els diferents processos de captació que la empresa ha d’efectuar per obtenir nous candidats


DROP FUNCTION modificacio_processoscaptacio(character varying,tipusprocescaptacio,date);
create or replace function modificacio_processoscaptacio(
	abm_codiproces varchar(10),
	abm_tipus tipusprocescaptacio,
	abm_datainici date,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova si existeixen dades duplicades al sistema.
	SELECT codiproces INTO id FROM uoc_recruitcat.processoscaptacio 
	WHERE tipus = abm_tipus 
	AND datainici = abm_datainici
	AND codiproces != abm_codiproces;
	IF FOUND THEN
	--Si existeixen es mostra un error al camp RSP.
		RSP ='ERROR JA EXISTEIX LA RELACIO '||abm_tipus ||' AMB LA DATA '||abm_datainici||' AMB ID '||id;

	ELSE
	-- Si NO existeixen s'actualitzen les dades amb les dades introduides.
		UPDATE  uoc_recruitcat.processoscaptacio
		SET tipus = abm_tipus, datainici = abm_datainici
		WHERE codiproces = abm_codiproces; 
		RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_processoscaptacio', abm_codiproces||', '|| abm_tipus||', '||abm_datainici,RSP);
-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_processoscaptacio', abm_codiproces||', '|| abm_tipus||', '||abm_datainici,RSP);
		
end
$$
language plpgsql;



--Taula procesoscaptacio - BAIXA //Manté els diferents processos de captació que la empresa ha d’efectuar per obtenir nous candidats


DROP FUNCTION baixa_processoscaptacio(character varying);
create or replace function baixa_processoscaptacio(
	abm_codiproces varchar(10) ,
	OUT RSP text
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--Es comprova si existeix la relació al sistema.
	SELECT codiproces INTO id FROM uoc_recruitcat.processoscaptacio 
	WHERE codiproces = abm_codiproces;
	-- Si NO es troba es mostra un error al camp RSP.
	IF NOT FOUND THEN
		RSP ='ERROR NO EXISTEIX LA RELACIO AMB ID '||abm_codiproces;

	ELSE
	-- Si es troba s'esborren les dades.
		DELETE FROM uoc_recruitcat.processoscaptacio		
		WHERE codiproces = abm_codiproces 		
		; RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_processoscaptacio', abm_codiproces,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_processoscaptacio', abm_codiproces,RSP);
		
end
$$
language plpgsql;



--Taula estatprocesscaptacio - ALTA //Guarda les dades de l’estat del procés de captació amb els candidats.


DROP FUNCTION alta_estatprocescaptacio(character varying,character varying,decisio);
create or replace function alta_estatprocescaptacio(
	abm_codiproces varchar(10),
	abm_codicandidat varchar(10),
	abm_estat decisio,
	OUT RSP text
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--S'insertten les daes al sistema. El sistema determina si existeixen dades duplicades.
	INSERT INTO uoc_recruitcat.estatprocescaptacio
	VALUES(abm_codiproces,abm_codicandidat,abm_estat);
	RSP = 'OK';
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_estatprocescaptacio', abm_codiproces||', '|| abm_codicandidat||', '||abm_estat, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_estatprocescaptacio', abm_codiproces||', '|| abm_codicandidat||', '||abm_estat, RSP);
		
end
$$
language plpgsql;


--Taula estatprocesscaptacio - MODIFICACIO //Guarda les dades de l’estat del procés de captació amb els candidats.


DROP FUNCTION modificacio_estatprocescaptacio(character varying,character varying,decisio);
create or replace function modificacio_estatprocescaptacio(
	abm_codiproces varchar(10),
	abm_codicandidat varchar(10),
	abm_estat decisio,
	OUT RSP text
 )
RETURNS TEXT AS
$$
declare id decisio;
begin
--Es comprova que existeixn dades per actualitzar
	SELECT estat INTO id FROM uoc_recruitcat.estatprocescaptacio WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
	IF NOT found THEN
	-- Si NO existeixen dades es mostra un error al camp RSP.
		RSP ='ERROR NO EXISTEIX LA RELACIO '||abm_codiproces ||' AMB EL CANDIDAT '||abm_codicandidat;
	ELSE
	-- Si existeixen dades s'actualitzen amb les dades introduides.
		UPDATE uoc_recruitcat.estatprocescaptacio
		SET estat = abm_estat 
		WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
RSP = 'OK';
	END IF;
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_estatprocescaptacio', abm_codiproces||', '|| abm_codicandidat||', '||abm_estat, RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_estatprocescaptacio', abm_codiproces||', '|| abm_codicandidat||', '||abm_estat, RSP);
	
end
$$
language plpgsql;


--Taula estatprocesscaptacio - BAIXA //Guarda les dades de l’estat del procés de captació amb els candidats.

DROP FUNCTION baixa_estatprocescaptacio(character varying,character varying);
create or replace function baixa_estatprocescaptacio(
	abm_codiproces varchar(10),
	abm_codicandidat varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id decisio;
begin
	--Es comprova si existeix dades al sistema amb les dades introduides
	SELECT estat INTO id FROM uoc_recruitcat.estatprocescaptacio WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
	IF NOT found THEN
	--Si NO existeixen es mostra un error al camp RSP
		RSP ='ERROR NO EXISTEIX LA RELACIO '||abm_codiproces ||' AMB EL CANDIDAT '||abm_codicandidat;
	ELSE
	--Si existeixen s'esborren del sistema
		DELETE FROM uoc_recruitcat.estatprocescaptacio		
		WHERE codiproces = abm_codiproces AND codicandidat = abm_codicandidat;
		RSP = 'OK';
	END IF; 
INSERT INTO  uoc_recruitcat.log VALUES('baixa_estatprocescaptacio', abm_codiproces, RSP);

-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_estatprocescaptacio', abm_codiproces, RSP);
end
$$
language plpgsql;



-- Taula propostespresentades - ALTA //Manté les dades referents a les propostes comercials presentades als clients


DROP FUNCTION alta_propostespresentades(character varying,double precision,date,decisio,character varying,character varying);
create or replace function alta_propostespresentades(
	abm_codiproposta varchar(10),	
	abm_import double precision,
	abm_data date,
	abm_estat decisio,
	abm_codiclient varchar(10),
	abm_codicomercial varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova si existeixen dades duplicades al sistema.
	SELECT codiproposta INTO id FROM uoc_recruitcat.propostespresentades 
	WHERE import = abm_import and data = abm_data AND codiclient = abm_codiclient;
	IF found THEN
	--Si existeixen es mostra un error al camp RSP del sistema.
		RSP ='ERROR JA EXISTEIX LA RELACIO AMB ID '||id ||' PEL CLIENT '||abm_codiclient||' AMB DATA '||abm_data||' PER UN IMPORT DE '||abm_import;
	ELSE
	--Si NO existeixen es guarden les noves dades al sistema.
		INSERT INTO uoc_recruitcat.propostespresentades		
		VALUES (abm_codiproposta, abm_import, abm_data, abm_estat, abm_codiclient, abm_codicomercial);			
RSP = 'OK';
	END IF; 
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_propostespresentades', abm_codiproposta||', '|| abm_import||', '|| abm_data||', '||abm_estat||', '||abm_codiclient||', '||abm_codicomercial ,RSP);

-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_propostespresentades', abm_codiproposta||', '|| abm_import||', '|| abm_data||', '||abm_estat||', '||abm_codiclient||', '||abm_codicomercial ,RSP);
	
end
$$
language plpgsql;



-- Taula propostespresentades - MODIFICACIO //Manté les dades referents a les propostes comercials presentades als clients

DROP FUNCTION modificacio_propostespresentades(character varying,double precision,date,decisio,character varying,character varying);
create or replace function modificacio_propostespresentades(
	abm_codiproposta varchar(10),
	abm_import double precision,
	abm_data date,
	abm_estat decisio,
	abm_codiclient varchar(10) ,
	abm_codicomercial varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--Es comprova si existeixen dades duplicades al sistema
	SELECT codiproposta INTO id FROM uoc_recruitcat.propostespresentades 
	WHERE import = abm_import and data = abm_data AND codiclient = abm_codiclient AND codiproposta!=abm_codiproposta;
	-- Si existeixen es mostra un error al camp RSP
	IF found THEN
		RSP ='ERROR JA EXISTEIX LA RELACIO AMB ID '||id ||' PEL CLIENT '||abm_codiclient||' AMB DATA '||abm_data||' PER UN IMPORT DE '||abm_import;
	ELSE
	--Si NO existeixen dades duplicades es modifiquen les dades al sistema.
		UPDATE uoc_recruitcat.propostespresentades 
		SET import = abm_import, data = abm_data, estat = abm_estat, codiclient = abm_codiclient, codicomercial = abm_codicomercial		
		WHERE codiproposta = abm_codiproposta;
		RSP = 'OK';
	END IF;	
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_propostespresentades', abm_codiproposta||', '|| abm_import||', '|| abm_data||', '||abm_estat||', '||abm_codiclient||', '||abm_codicomercial ,RSP);

-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_propostespresentades', abm_codiproposta||', '|| abm_import||', '|| abm_data||', '||abm_estat||', '||abm_codiclient||', '||abm_codicomercial ,RSP);
end
$$	
language plpgsql;



-- Taula propostespresentades - BAIXA //Manté les dades referents a les propostes comercials presentades als clients


DROP FUNCTION baixa_propostespresentades(character varying);
create or replace function baixa_propostespresentades(
	abm_codiproposta varchar(10) ,
	OUT RSP text	
 )	
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	-- Es comprova si existeixen les dades al sistema
	SELECT codiproposta INTO id FROM uoc_recruitcat.propostespresentades 
	WHERE codiproposta=abm_codiproposta;
	IF NOT found THEN
	--Si NO existeixen es mostra un error al camp RSP
		RSP ='ERROR NO EXISTEIX LA RELACIO AMB ID '||id;
	ELSE
	--Si existeixen s'esborren del sistema.
		DELETE FROM uoc_recruitcat.propostespresentades 				
		WHERE codiproposta = abm_codiproposta;
		RSP = 'OK';
	END IF; 
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('baixa_propostespresentades', abm_codiproposta,RSP);

-- Catch errors
EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_propostespresentades', abm_codiproposta,RSP);
	
end
$$
language plpgsql;



--Taula competenciesperproces - ALTA //Manté la llista de les diferents competències professionals que té un  procés de selecció

DROP FUNCTION alta_competenciesperproces(character varying,character varying);
create or replace function alta_competenciesperproces(
	abm_codiproces varchar(10),
	abm_codicompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--S'insereix les dades al sistema, el sistema comprova si són duplicades.
	INSERT INTO uoc_recruitcat.competenciesperproces 		
	VALUES (abm_codiproces, abm_codicompetencia);
	RSP = 'OK'; 
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('alta_competenciesperproces', abm_codiproces||', '||abm_codicompetencia,RSP);

EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('alta_competenciesperproces', abm_codiproces||', '||abm_codicompetencia,RSP);

		
end
$$
language plpgsql;


--Taula competenciesperproces - MODIFICACIO //Manté la llista de les diferents competències professionals que té un  procés de selecció

DROP FUNCTION modificacio_competenciesperproces(character varying,character varying,character varying);
create or replace function modificacio_competenciesperproces(
	abm_codiproces varchar(10),
	abm_codicompetencia varchar(10),
	abm_novacompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
	--S'actualitzen les dades al sistema, el sistema comprova si són duplicades.
	UPDATE uoc_recruitcat.competenciesperproces 		
	SET codicompetencia = abm_novacompetencia
	WHERE codiproces = abm_codiproces AND codicompetencia = abm_codicompetencia;
	RSP = 'OK'; 
	-- S'insereix el resultat de la consulta en qualsevol cas al log.
INSERT INTO  uoc_recruitcat.log VALUES('modificacio_competenciesperproces', abm_codiproces||', '||abm_codicompetencia||', '||abm_novacompetencia,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('modificacio_competenciesperproces', abm_codiproces||', '||abm_codicompetencia||', '||abm_novacompetencia,RSP);
		
end
$$
language plpgsql;



--Taula competenciesperproces - BAIXA //Manté la llista de les diferents competències professionals que té un  procés de selecció


DROP FUNCTION baixa_competenciesperproces(character varying,character varying);
create or replace function baixa_competenciesperproces(
	abm_codiproces varchar(10),
	abm_codicompetencia varchar(10) ,
	OUT RSP text	
 )
RETURNS TEXT AS
$$
declare id varchar(10);
begin
--Es comprova si les dades existeixen al sistema
	SELECT codicompetencia INTO id FROM uoc_recruitcat.competenciesperproces WHERE codiproces = abm_codiproces AND codicompetencia = abm_codicompetencia;
	IF NOT FOUND THEN
	--Si NO existeixen es mostra un error al camp RSP
		RSP ='ERROR NO EXISTEIX LA RELACIO '||abm_codiproces||' AMB LA COMPETENCIA AMB ID '||abm_codicompetencia;

	ELSE
	--Si existeixen s'esborren del sistema.
		DELETE FROM uoc_recruitcat.competenciesperproces 		
		WHERE codiproces = abm_codiproces AND codicompetencia = abm_codicompetencia;
		RSP = 'OK';
	END IF; 
INSERT INTO  uoc_recruitcat.log VALUES('baixa_competenciesperproces', abm_codiproces||', '||abm_codicompetencia,RSP);
-- Catch errors
 EXCEPTION     
     WHEN OTHERS THEN
	--Es captura l'error de l'SQL al camp RSP.
	RSP = 'ERROR '||SQLERRM;
	--Es guarda al log.
	INSERT INTO  uoc_recruitcat.log VALUES('baixa_competenciesperproces', abm_codiproces||', '||abm_codicompetencia,RSP);
		
end
$$
language plpgsql;
